*********************************************************************
*Radios-link-mania - programa para buscar rdios;
*Por Fabiano Ferreira;
*Verso 2020.1 em 27/05/2020;
*********************************************************************

seja $versao "2021.1"

@inicio
seja $pagina_atual 0
seja $escritos 0
seja $fontes_encontradas 0
seja $fontes_nao_encontradas 0
seja $txt_temp "c:\radioslinkmania\temp\radios.txt"
seja o ""
seja $nr 0
remove $txt_temp &
seja $args params
chama @entrada
chama @pesquisa
se $encontradas = 0
escreve mudo "Nenhum resultado foi encontrado."
mensagem "c:\radioslinkmania\som\nenhum_resultado_foi_encontrado.wav"
se $args <> "0" termina mudo
desvia @inicio
fim se
escreve mudo $encontradas " resultados encontrados"
mensagem "c:\radioslinkmania\som\numero_de_resultados_encontrados.wav"
fala $encontradas
seja $total_encontradas $encontradas
escreve ""
escreve mudo "Aguarde o processamento das informaes."
mensagem "c:\radioslinkmania\som\aguarde_o_processamento_das_informacoes.wav"
chama @processa
escreve mudo "Pronto."
mensagem "c:\radioslinkmania\som\pronto.wav"
escreve ""
@quergerarm3u
se o = "s"
dir troca "c:\radioslinkmania\m3u"
chama @geram3u
fim se
se $args <> "0"
se $nr = 1 termina mudo
chama @exibe_informacoes
fim se
se $args <> "0" termina mudo
escreve mudo "Deseja gerar m3u das rdios encontradas?"
mensagem "c:\radioslinkmania\som\deseja_gerar_m3u_das_radios_encontradas.wav"
le mudo o &
se o = "s"
escreve mudo "Aguarde."
mensagem "c:\radioslinkmania\som\aguarde.wav"
dir troca "c:\radioslinkmania\m3u"
chama @geram3u
escreve mudo "Ok"
mensagem "c:\radioslinkmania\som\ok.wav"
seno
se o = "n"
*no faz nada
seno
desvia @quergerarm3u
fim se
escreve mudo "Mostrando resultado."
mensagem "c:\radioslinkmania\som\mostrando_resultado.wav"
chama @exibe_informacoes
desvia @inicio

*

*entrada
@entrada
seja $aguarda 0
dir troca "c:\radioslinkmania"
se $args = "0"
escreve mudo "Radios-link-mania - verso "$versao
mensagem "c:\radioslinkmania\som\radios_link_mania_versao.wav"
fala $versao
escreve ""
fim se
retorna

*pesquisa
@pesquisa
se $args = "0"
escreve mudo "Entre com os dados para a pesquisa de rdios:"
mensagem "c:\radioslinkmania\som\entre_com_os_dados_para_a_pesquisa_de_radios.wav"
le $abuscar
seno
seja $abuscar $args
seja p pos "/nr" $abuscar
se p > 0 seja $nr 1
se p > 0 substitui $abuscar "/nr" ""
seja p pos "/m3u" $abuscar
se p > 0 seja o "s"
se p > 0 substitui $abuscar "/m3u" ""
seja p pos "/p=" $abuscar
se p = 0 termina mudo
soma p 3
seja t tamanho $abuscar
copia $abuscar $abuscar p t
seja $abuscar trim $abuscar
fim se
se $abuscar = ""
escreve mudo "At logo."
mensagem "c:\radioslinkmania\som\ate_logo.wav"
termina mudo
fim se
seja $suapesquisa $abuscar
escreve ""
escreve mudo "Aguarde."
mensagem "c:\radioslinkmania\som\aguarde.wav"
*faz a pesquisa no radios.com.br
seja $arqtemp "temp\radios.html"
seja $baseurl "https://www.radios.com.br/busca?q="
seja $filtro "&qfilter=completo"
seja $recurso $baseurl

ansiparautf8 $abuscar
http $abuscar
substitui $abuscar "%20" "+"
concatena $recurso $abuscar
concatena $recurso $filtro
seja $recurso_cp $recurso
@acao_traz_pesquisa
remove $arqtemp &
trazdarede $recurso $arqtemp 0 "webvox" "" x
se x <> 0
escreve mudo  "Erro ao realizar a pesquisa."
escreve mudo "Verifique sua conexo com a internet."
mensagem "c:\radioslinkmania\som\erro_ao_realizar_a_pesquisa_verifique_sua_conexao_com_a_internet.wav"
espera 5
termina mudo
fim se
se $pagina_atual > 0 retorna

abre #1 $arqtemp
le #1 $encontradas
checa c
enquanto c = 0
se $encontradas *=* ">Mostrando " desvia @achouresultado
le #1 $encontradas
checa c
fim enquanto
se c = 1
Escreve "Erro no aplicativo radioslinkmania."
escreve "No foi possvel obter o valor da varivel $encontradas."
escreve "Encerrando..."
espera 5
fecha #1
termina mudo
fim se
@achouresultado
fecha #1

seja p pos " de " $encontradas
soma p 4
seja t pos "resultados" $encontradas
subtrai t 2
copia $encontradas $encontradas p t
retorna
*

@processa
chama @acao_definir_total_paginas
chama @acao_tratar_dados_radios
chama @obtem_fonte
retorna

@acao_definir_total_paginas
se $encontradas <= 22
seja $total_paginas 1
seno
seja $total_paginas $encontradas
divide $total_paginas 22
seja $resto $total_paginas
multiplica $resto 22
seja $resto ($encontradas-$resto)
se $resto > 0 soma $total_paginas 1
subtrai $total_paginas 1
fim se
retorna

@acao_tratar_dados_radios
seja m ""
seja $segmentoradio ""

abre #1 $arqtemp
le #1 l
checa c
enquanto c = 0
concatena m l
le #1 l
checa c
fim enquanto
fecha #1

seja p pos "panel-body" m
seja t tamanho m
copia m m p t
seja p pos "resultados-sidebar" m
copia m m 1 p

 abre #2 $txt_temp &
se $encontradas > 22
seja n 22
seja $encontradas ($encontradas -22)
seno
seja n $encontradas
fim se
repete r n
escreve #2 ""
seja p pos "alt=" m
soma p 5
seja t tamanho m
copia m m p t
seja p pos """" m
subtrai p 1
copia $nomeradio m 1 p
 seja p pos "localizacao"" href=" m
seja t tamanho m
copia m m p t
seja p pos """>" m
soma p 2
seja t tamanho m
copia m m p t
seja p pos "<" m
subtrai p 1
copia $localradio m 1 p

seja p pos "alt=" m
se p = 0 seja p tamanho m
subtrai p 1
copia z m 1 p
seja p pos "/radio/segmento" z
enquanto p > 0
seja t tamanho z
copia z z p t
seja p pos """>" z
soma p 2
seja t tamanho z
copia z z p t
seja p pos "<" z
subtrai p 1
copia x z 1 p
soma p 2
seja t tamanho z
copia z z p t
se $segmentoradio <> ""
concatena $segmentoradio ", "
concatena $segmentoradio x
seno
seja $segmentoradio x
fim se
seja p pos "/radio/segmento" z
fim enquanto

seja p pos "btn-primary"" href=" m
soma p 19
seja t tamanho m
copia m m p t
seja p pos """" m
subtrai p 1
copia $urlradio m 1 p

seja p pos "/" $urlradio
enquanto p > 0
soma p 1
seja t tamanho $urlradio
copia $urlradio $urlradio p t
seja p pos "/" $urlradio
fim enquanto
seja x "http://www.radios.com.br/play/"
concatena x $urlradio
seja $urlradio x
soma $escritos 1
escreve #2 $escritos ". "&
utf8paraansi $nomeradio
escreve #2 $nomeradio
utf8paraansi $localradio
escreve #2 $localradio
utf8paraansi $segmentoradio
escreve #2 $segmentoradio
seja $segmentoradio ""
escreve #2 $urlradio
fim repete
fecha #2
se $total_encontradas <= 22 retorna
seja $recurso $recurso_cp
soma $pagina_atual 1
se $pagina_atual > $total_paginas retorna
concatena $recurso "&pg="
concatena $recurso $pagina_atual
*bipa
toca "c:\radioslinkmania\som\processamento.wav"&
chama @acao_traz_pesquisa
desvia @acao_tratar_dados_radios

@obtem_fonte
seja $informacoes "c:\radioslinkmania\temp\radios.info"
remove $informacoes &
abre #1 $informacoes &
chama @apresentacao
abre #2 $txt_temp
le #2 l
checa c
enquanto c = 0
repete r 4
escreve #1 l
le #2 l
fim repete
chama @traz_fonte
escreve #1 $achoufonte
escreve #1 l
*bipa 1
toca "c:\radioslinkmania\som\processamento.wav"&
le #2 l
checa c
fim enquanto
escreve #1 "-----------------------------------------------------------------------"
escreve #1 "Streamings encontrados: "$fontes_encontradas", num total de "$total_encontradas

seja $resolvidos $fontes_encontradas
multiplica $resolvidos 100
divide $resolvidos $total_encontradas
escreve #1 $resolvidos "% resolvido"
fecha #2
fecha #1
retorna

@traz_fonte
seja $achoufonte "-"
seja $fontetemp "c:\radioslinkmania\temp\fonte.temp"
remove $fontetemp &
trazdarede l $fontetemp 0 "webvox" "" x
abre #3 $fontetemp
le #3 s
checa c
enquanto c = 0
se s *=* "src:  """ desvia @achou_fonte
le #3 s
checa c
fim enquanto
@achou_fonte
fecha #3
se c = 0
seja p pos "src:  " s
soma p 7
seja t tamanho s
copia s s p t
seja p pos """" s
subtrai p 1
copia s s 1 p
seja l s
seja $achoufonte "+"
soma $fontes_encontradas 1
seno
soma $fontes_nao_encontradas 1
fim se
retorna

@exibe_informacoes
seja $progleitor "c:\winvox\edivox.exe /L "
concatena $progleitor $informacoes
executa $progleitor
retorna

@apresentacao
escreve #1 "Radios-link-mania - dados encontrados na pesquisa por "$suapesquisa
escreve #1 ""
escreve #1 "Modelo do documento:"
escreve #1 "Nome da rdio"
escreve #1 "Cidade"
escreve #1 "Gnero (havendo vrios, so escritos na mesma linha, separados por vrgula)"
escreve #1 "+ indicando que o streaming foi encontrado ou - indicando que no foi"
escreve #1 "Se o streaming foi encontrado, escreve. Seno, escreve o link do player do radios.com.br"
escreve #1 "------------------------------------------------------------------------------"
retorna

@geram3u
abre #1 $informacoes
repete r 11
le #1 $nomem3u
fim repete
checa c
enquanto c = 0
le #1 $cidadem3u
le #1 l
le #1 $sinal
le #1 l
se $sinal = "+" chama @criam3u
le #1 l
le #1 $nomem3u
checa c
fim enquanto
fecha #1
retorna

@criam3u

seja p pos ". " $nomem3u
soma p 2
seja t tamanho $nomem3u
copia $nomem3u $nomem3u p t

busca b dir $suapesquisa
se b = "" dir cria $suapesquisa

seja $arqm3u "c:\radioslinkmania\m3u\"
concatena $arqm3u $suapesquisa
concatena $arqm3u "\"
concatena $arqm3u $nomem3u
concatena $arqm3u " - "
concatena $arqm3u $cidadem3u
concatena $arqm3u ".m3u"
substitui $arqm3u "/" " "
substitui $arqm3u "|" " "
substitui $arqm3u "?" " "
substitui $arqm3u "<" " "
substitui $arqm3u ">" " "
remove $arqm3u &
abre #2 $arqm3u &
escreve #2 l
fecha #2
retorna
